//+------------------------------------------------------------------+
//|                                               generate tick data |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#include <WinUser32.mqh>
#define  CHART_CMD_UPDATE_DATA 33324

//
//
//
//
//

extern bool ResetData   = false;
extern bool ShowComment = false;

//
//
//
//
//

int      fileHandle = -1;
int      filePeriod =  1;
string   fileSymbol;

//+------------------------------------------------------------------
//
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   fileSymbol = "_t"+Symbol();
      if (OpenHistoryFile()<0) return(-1);
   return (0);
}
void deinit()
{
   if (fileHandle >= 0) { FileClose(fileHandle);  fileHandle = -1; }
   if (ShowComment) Comment("");
}

//+------------------------------------------------------------------
//
//+------------------------------------------------------------------
//
//
//
//
//

int OpenHistoryFile()
{
   string name = fileSymbol+filePeriod;
      if (ResetData)
            fileHandle = FileOpenHistory(name + ".hst", FILE_BIN|FILE_WRITE);
      else  fileHandle = FileOpenHistory(name + ".hst", FILE_BIN|FILE_WRITE|FILE_READ);
       
      //
      //
      //
      //
      //
       
      if (fileHandle >=0)
      {
         int size = FileSeek(fileHandle,0,SEEK_END);
         if (size<148)
                     WriteHistoryHeader();
         return(0);
      }
      else return(-1);
}

//
//
//
//
//

int WriteHistoryHeader()
{
   string c_copyright  = "(C)opyright 2003, MetaQuotes Software Corp.";
   int    digits       = Digits;
   int    unused[13]   = {0};
   int    version      = 400;   

   if (fileHandle >= 0)
   {
      FileWriteInteger(fileHandle, version, LONG_VALUE);
      FileWriteString(fileHandle, c_copyright, 64);
      FileWriteString(fileHandle, fileSymbol , 12);
      FileWriteInteger(fileHandle, filePeriod, LONG_VALUE);
      FileWriteInteger(fileHandle, digits    , LONG_VALUE);
      FileWriteInteger(fileHandle, 0         , LONG_VALUE);
      FileWriteInteger(fileHandle, 0         , LONG_VALUE);
      FileWriteArray(fileHandle, unused, 0, ArraySize(unused));
                 FileFlush(fileHandle);
   }
   return (0);
}

//
//
//
//
//

void WriteHistoryData(datetime time, double price)
{
   if (fileHandle >= 0)
   if (FileSeek(fileHandle,0,SEEK_END))
   {
      FileWriteInteger(fileHandle, time, LONG_VALUE);
      FileWriteDouble(fileHandle, price, DOUBLE_VALUE);
      FileWriteDouble(fileHandle, price, DOUBLE_VALUE);
      FileWriteDouble(fileHandle, price, DOUBLE_VALUE);
      FileWriteDouble(fileHandle, price, DOUBLE_VALUE);
      FileWriteDouble(fileHandle, 1    , DOUBLE_VALUE);
            FileFlush(fileHandle);
            if (ShowComment)
                     Comment("tick saved at : "+TimeToStr(TimeLocal(),TIME_SECONDS));
   }
}

//
//
//
//
//

int UpdateChartWindow()
{
   static int hwnd = 0;

   if(fileHandle < 0) return (-1);
   if(hwnd == 0) hwnd = WindowHandle(fileSymbol,filePeriod);
   if(hwnd != 0)
   {
      if (IsDllsAllowed())
      if (PostMessageA(hwnd,WM_COMMAND,CHART_CMD_UPDATE_DATA,0) == 0) hwnd = 0;
   }
   return (0);
}

//+------------------------------------------------------------------
//
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   if (fileHandle<0) return(0);

         WriteHistoryData(TimeCurrent(),Bid);
         UpdateChartWindow();
}